
import java.util.*;
import java.io.*;

public class doubleclique_font
{
   public static void main(String[] args) throws Exception
   {
      PrintWriter out = new PrintWriter(System.out);
      new doubleclique_font(new FastScanner(System.in), out);
      out.close();
   }

   public doubleclique_font(FastScanner in, PrintWriter out)
   {
      int N = in.nextInt();
      int M = in.nextInt();
      int[] deg = new int[N];
      ArrayList<Integer>[] adj = new ArrayList[N];
      for (int i=0; i<N; i++)
         adj[i] = new ArrayList<>();
   
      for (int u=0; u<M; u++)
      {
         int i = in.nextInt()-1;
         int j = in.nextInt()-1;
         adj[i].add(j);
         adj[j].add(i);
         deg[i]++;
         deg[j]++;
      }

      Node[] nodes = new Node[N];
      for (int i=0; i<N; i++)
         nodes[i] = new Node(i, deg[i]);
      Arrays.sort(nodes);
     
      // Look for the largest clique.
      // Nodes in [0, sp) form our independent set
      // Nodes in [sp, N) form our clique
      int res = 0;
      int numCliqueEdges = M;
      boolean[] independent = new boolean[N];
      for (int sp=0; sp<N; sp++)
      {
         int numCliqueNodes = N-sp;
         long numEdgesNeeded = (numCliqueNodes - 1L) * numCliqueNodes / 2L;
         if (numEdgesNeeded == numCliqueEdges)
         {
            // Found the clique! 
            // Find all possible cliques that remove one node that work.
               
            // Take the whole clique.
            res++;

            // Find all nodes that can be absent from the clique.
            for (int pos=sp; pos<N; pos++)
            {
               int i = nodes[pos].index;
               boolean isLocked = false;
               for (int j : adj[i])
                  if (independent[j])
                     isLocked = true;
               if (!isLocked)
                  res++;
            }

            // Is it possible to remove the smallest degree node?
            // Do other nodes successfully replace it?
            if (sp < N && nodes[sp].degree < nodes[sp+1].degree)
            {
               boolean allInternal = true;
               for (int j : adj[nodes[sp].index])
                  if (independent[j])
                     allInternal = false;
           
               // This node is removeable, do any other replace it?
               if (allInternal)
               {
                  // Try all replacements for the node
                  for (int x=0; x<sp; x++)
                     if (nodes[x].degree == nodes[sp].degree)
                        res++;
               }
            }

            // Only consider the largest clique
            break;
         }

         // Add nodes[sp] to our independant set
         boolean isBroken = false;
         independent[nodes[sp].index] = true;
         for (int j : adj[nodes[sp].index])
         {
            if (independent[j])
               isBroken = true;
            else
               numCliqueEdges--;
         }

         // Check for break condition (an independent edge exists)
         if (isBroken)
            break;
      }

      out.println(res);
   }

   class Node implements Comparable<Node>
   {
      int index, degree;

      Node(int index, int degree)
      {
         this.index = index;
         this.degree = degree;
      }

      public int compareTo(Node rhs)
      {
         return Integer.compare(degree, rhs.degree);
      }
   }
}

class FastScanner{
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar;
    private int numChars;
    
    public FastScanner(InputStream stream)
    {
        this.stream = stream;
    }
    
    int read()
    {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars){
            curChar = 0;
            try{
                numChars = stream.read(buf);
            } catch (IOException e) {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }
    
    boolean isSpaceChar(int c)
    {
        return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
    }
    
    boolean isEndline(int c)
    {
        return c=='\n'||c=='\r'||c==-1;
    }
    
    int nextInt()
    {
        return Integer.parseInt(next());
    }
    
    long nextLong()
    {
        return Long.parseLong(next());
    }
    
    double nextDouble()
    {
        return Double.parseDouble(next());
    }
    
    String next(){
        int c = read();
        while (isSpaceChar(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do{
            res.appendCodePoint(c);
            c = read();
        }while(!isSpaceChar(c));
        return res.toString();
    }
    
    String nextLine(){
        int c = read();
        while (isEndline(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do{
            res.appendCodePoint(c);
            c = read();
        }while(!isEndline(c));
        return res.toString();
    }
}
